# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiCloudaccountsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'cloud_account_type': 'str',
        'private_key_id': 'str',
        'private_key': 'str',
        'associated_cloud_account_ids': 'list[str]',
        'associated_mobility_cloud_account_ids': 'dict(str, str)',
        'cloud_account_properties': 'dict(str, str)',
        'custom_properties': 'dict(str, str)',
        'regions': 'list[IaasapicloudaccountsvsphereRegions]',
        'create_default_zones': 'bool',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'certificate_info': 'IaasapiintegrationsCertificateInfo'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'cloud_account_type': 'cloudAccountType',
        'private_key_id': 'privateKeyId',
        'private_key': 'privateKey',
        'associated_cloud_account_ids': 'associatedCloudAccountIds',
        'associated_mobility_cloud_account_ids': 'associatedMobilityCloudAccountIds',
        'cloud_account_properties': 'cloudAccountProperties',
        'custom_properties': 'customProperties',
        'regions': 'regions',
        'create_default_zones': 'createDefaultZones',
        'tags': 'tags',
        'certificate_info': 'certificateInfo'
    }

    def __init__(self, name=None, description=None, cloud_account_type=None, private_key_id=None, private_key=None, associated_cloud_account_ids=None, associated_mobility_cloud_account_ids=None, cloud_account_properties=None, custom_properties=None, regions=None, create_default_zones=None, tags=None, certificate_info=None):  # noqa: E501
        """ApiCloudaccountsBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._cloud_account_type = None
        self._private_key_id = None
        self._private_key = None
        self._associated_cloud_account_ids = None
        self._associated_mobility_cloud_account_ids = None
        self._cloud_account_properties = None
        self._custom_properties = None
        self._regions = None
        self._create_default_zones = None
        self._tags = None
        self._certificate_info = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.cloud_account_type = cloud_account_type
        if private_key_id is not None:
            self.private_key_id = private_key_id
        if private_key is not None:
            self.private_key = private_key
        if associated_cloud_account_ids is not None:
            self.associated_cloud_account_ids = associated_cloud_account_ids
        if associated_mobility_cloud_account_ids is not None:
            self.associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids
        self.cloud_account_properties = cloud_account_properties
        if custom_properties is not None:
            self.custom_properties = custom_properties
        self.regions = regions
        if create_default_zones is not None:
            self.create_default_zones = create_default_zones
        if tags is not None:
            self.tags = tags
        if certificate_info is not None:
            self.certificate_info = certificate_info

    @property
    def name(self):
        """Gets the name of this ApiCloudaccountsBody.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiCloudaccountsBody.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this ApiCloudaccountsBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this ApiCloudaccountsBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiCloudaccountsBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this ApiCloudaccountsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def cloud_account_type(self):
        """Gets the cloud_account_type of this ApiCloudaccountsBody.  # noqa: E501

        Cloud account type  # noqa: E501

        :return: The cloud_account_type of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_type

    @cloud_account_type.setter
    def cloud_account_type(self, cloud_account_type):
        """Sets the cloud_account_type of this ApiCloudaccountsBody.

        Cloud account type  # noqa: E501

        :param cloud_account_type: The cloud_account_type of this ApiCloudaccountsBody.  # noqa: E501
        :type: str
        """
        if cloud_account_type is None:
            raise ValueError("Invalid value for `cloud_account_type`, must not be `None`")  # noqa: E501

        self._cloud_account_type = cloud_account_type

    @property
    def private_key_id(self):
        """Gets the private_key_id of this ApiCloudaccountsBody.  # noqa: E501

        Access key id or username to be used to authenticate with the cloud account  # noqa: E501

        :return: The private_key_id of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: str
        """
        return self._private_key_id

    @private_key_id.setter
    def private_key_id(self, private_key_id):
        """Sets the private_key_id of this ApiCloudaccountsBody.

        Access key id or username to be used to authenticate with the cloud account  # noqa: E501

        :param private_key_id: The private_key_id of this ApiCloudaccountsBody.  # noqa: E501
        :type: str
        """

        self._private_key_id = private_key_id

    @property
    def private_key(self):
        """Gets the private_key of this ApiCloudaccountsBody.  # noqa: E501

        Secret access key or password to be used to authenticate with the cloud account. In case of AAP pass a dummy value.  # noqa: E501

        :return: The private_key of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: str
        """
        return self._private_key

    @private_key.setter
    def private_key(self, private_key):
        """Sets the private_key of this ApiCloudaccountsBody.

        Secret access key or password to be used to authenticate with the cloud account. In case of AAP pass a dummy value.  # noqa: E501

        :param private_key: The private_key of this ApiCloudaccountsBody.  # noqa: E501
        :type: str
        """

        self._private_key = private_key

    @property
    def associated_cloud_account_ids(self):
        """Gets the associated_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501

        Cloud accounts to associate with this cloud account  # noqa: E501

        :return: The associated_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._associated_cloud_account_ids

    @associated_cloud_account_ids.setter
    def associated_cloud_account_ids(self, associated_cloud_account_ids):
        """Sets the associated_cloud_account_ids of this ApiCloudaccountsBody.

        Cloud accounts to associate with this cloud account  # noqa: E501

        :param associated_cloud_account_ids: The associated_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501
        :type: list[str]
        """

        self._associated_cloud_account_ids = associated_cloud_account_ids

    @property
    def associated_mobility_cloud_account_ids(self):
        """Gets the associated_mobility_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501

        Cloud Account IDs and directionalities create associations to other vSphere cloud accounts that can be used for workload mobility. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional. Only supported on vSphere cloud accounts.  # noqa: E501

        :return: The associated_mobility_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._associated_mobility_cloud_account_ids

    @associated_mobility_cloud_account_ids.setter
    def associated_mobility_cloud_account_ids(self, associated_mobility_cloud_account_ids):
        """Sets the associated_mobility_cloud_account_ids of this ApiCloudaccountsBody.

        Cloud Account IDs and directionalities create associations to other vSphere cloud accounts that can be used for workload mobility. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional. Only supported on vSphere cloud accounts.  # noqa: E501

        :param associated_mobility_cloud_account_ids: The associated_mobility_cloud_account_ids of this ApiCloudaccountsBody.  # noqa: E501
        :type: dict(str, str)
        """
        allowed_values = ["UNIDIRECTIONAL", "BIDIRECTIONAL"]  # noqa: E501
        if not set(associated_mobility_cloud_account_ids.keys()).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid keys in `associated_mobility_cloud_account_ids` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(associated_mobility_cloud_account_ids.keys()) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids

    @property
    def cloud_account_properties(self):
        """Gets the cloud_account_properties of this ApiCloudaccountsBody.  # noqa: E501

        Cloud Account specific properties supplied in as name value pairs  # noqa: E501

        :return: The cloud_account_properties of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._cloud_account_properties

    @cloud_account_properties.setter
    def cloud_account_properties(self, cloud_account_properties):
        """Sets the cloud_account_properties of this ApiCloudaccountsBody.

        Cloud Account specific properties supplied in as name value pairs  # noqa: E501

        :param cloud_account_properties: The cloud_account_properties of this ApiCloudaccountsBody.  # noqa: E501
        :type: dict(str, str)
        """
        if cloud_account_properties is None:
            raise ValueError("Invalid value for `cloud_account_properties`, must not be `None`")  # noqa: E501

        self._cloud_account_properties = cloud_account_properties

    @property
    def custom_properties(self):
        """Gets the custom_properties of this ApiCloudaccountsBody.  # noqa: E501

        Additional custom properties that may be used to extend the Cloud Account. In case of AAP, provide environment property here.Example: \"customProperties\": {         \"environment\": \"aap\"     }   # noqa: E501

        :return: The custom_properties of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this ApiCloudaccountsBody.

        Additional custom properties that may be used to extend the Cloud Account. In case of AAP, provide environment property here.Example: \"customProperties\": {         \"environment\": \"aap\"     }   # noqa: E501

        :param custom_properties: The custom_properties of this ApiCloudaccountsBody.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    @property
    def regions(self):
        """Gets the regions of this ApiCloudaccountsBody.  # noqa: E501

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.  'regionInfos' is a required parameter for AWS, AZURE, GCP, VSPHERE, VMC, VCF cloud account types.  # noqa: E501

        :return: The regions of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: list[IaasapicloudaccountsvsphereRegions]
        """
        return self._regions

    @regions.setter
    def regions(self, regions):
        """Sets the regions of this ApiCloudaccountsBody.

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.  'regionInfos' is a required parameter for AWS, AZURE, GCP, VSPHERE, VMC, VCF cloud account types.  # noqa: E501

        :param regions: The regions of this ApiCloudaccountsBody.  # noqa: E501
        :type: list[IaasapicloudaccountsvsphereRegions]
        """
        if regions is None:
            raise ValueError("Invalid value for `regions`, must not be `None`")  # noqa: E501

        self._regions = regions

    @property
    def create_default_zones(self):
        """Gets the create_default_zones of this ApiCloudaccountsBody.  # noqa: E501

        Create default cloud zones for the enabled regions.  # noqa: E501

        :return: The create_default_zones of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: bool
        """
        return self._create_default_zones

    @create_default_zones.setter
    def create_default_zones(self, create_default_zones):
        """Sets the create_default_zones of this ApiCloudaccountsBody.

        Create default cloud zones for the enabled regions.  # noqa: E501

        :param create_default_zones: The create_default_zones of this ApiCloudaccountsBody.  # noqa: E501
        :type: bool
        """

        self._create_default_zones = create_default_zones

    @property
    def tags(self):
        """Gets the tags of this ApiCloudaccountsBody.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :return: The tags of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this ApiCloudaccountsBody.

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :param tags: The tags of this ApiCloudaccountsBody.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def certificate_info(self):
        """Gets the certificate_info of this ApiCloudaccountsBody.  # noqa: E501


        :return: The certificate_info of this ApiCloudaccountsBody.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this ApiCloudaccountsBody.


        :param certificate_info: The certificate_info of this ApiCloudaccountsBody.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiCloudaccountsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiCloudaccountsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
